//************************************************************************************************************************
//                                                  Gestionnaire d'vnements
//************************************************************************************************************************

// Au chargement de la page. 
 window.onload=initialisation;

 function initialisation() {

 twAffHeure();
 
// Toutes les secondes on lance une requte permettant de rafrachir la page si ncessaire  
  setInterval("rafraichir()",1000);   

// Gestion du bouton "valider".  
 document.getElementById("valider").onmouseup=function () { eclairer('valider'); }
 document.getElementById("valider").onmousedown=function () { foncer('valider'); }
 document.getElementById("valider").onmouseout= function () { retournormal('valider'); }
 document.getElementById("valider").onmouseover=function () { eclairer('valider'); }
 document.getElementById("valider").onclick=function () { validmessage(document.saisie.pseudo.value,document.saisie.message.value); }
 
// Gestion du bloc de saisie du pseudo.  
 document.getElementById("textpseudo").onkeyup=function () { verifPseudo(document.saisie.pseudo.value); }

// Gestion du bouton "effacer".   
 document.getElementById("effacer").onmouseup=function () { eclairer('effacer'); }
 document.getElementById("effacer").onmousedown=function () { foncer('effacer'); }
 document.getElementById("effacer").onmouseout= function () { retournormal('effacer'); }
 document.getElementById("effacer").onmouseover=function () { eclairer('effacer'); }
 document.getElementById("effacer").onclick=function () { eff(); }

 // Gestion des boutons  "couleurs".   
 document.getElementById("couleur1").onclick=function () { change_couleur('#63030a'); }
 document.getElementById("couleur2").onclick=function () { change_couleur('#060d85'); }
 document.getElementById("couleur3").onclick=function () { change_couleur('#06484b'); }
 
 
 }
 
// A la fermeture de la page (onunload pose des problmes avec Internet Explorer). 
window.onbeforeunload=fin;
function fin() {
eff('tout');
}

//************************************************************************************************************************
//                                                                Les fonctions et les moteurs Ajax
//************************************************************************************************************************


// Cette variable indique que la saisie du pseudo et du message est possible (ou pas).
var possible=true;



//***********************************************************************
// Les trois fonctions suivantes permettent de grer l'apparence des boutons lumineux.
//***********************************************************************

function foncer(nom){
		document.getElementById(nom).style.background="#b6b64c";	
		document.getElementById(nom).style.border="3px solid #2b3030";	
} 

function retournormal(nom){
		document.getElementById(nom).style.background="#2b3030";																  
		document.getElementById(nom).style.color="yellow";
		document.getElementById(nom).style.border="2px solid yellow";
} 

function eclairer(nom){
		document.getElementById(nom).style.background="yellow";	
		document.getElementById(nom).style.color="#2b3030";
		document.getElementById(nom).style.border="2px solid #2b3030";	
} 

//******************************************************************************
// Les trois fonctions suivantes permettent l'affichage et l'enregistrement de l'heure courante.
//******************************************************************************

// La  premire rajoute un zro pour avoir 2 chiffres pour les heures, les minutes et les secondes.
function twZero(_nbr) {
	return (_nbr < 10) ? '0' + _nbr : _nbr; 
}
//On surcharge l'objet Date.
Date.prototype.twHeure=function (){
  	var sHeures = twZero(this.getHours());
	var sMinutes = twZero(this.getMinutes());
	var sSecondes = twZero(this.getSeconds());
	var sTemp = "";
  	sTemp = sHeures + 'h' + sMinutes + 'min' + sSecondes  + 's' ; 
  	return sTemp;
}
// Cette fonction utilise un appel rcursif et permet l'affichage de l'heure toutes les secondes dans le bloc dont l'identifiant est "heure" .
function twAffHeure() {
	var dDate = new Date();
	document.getElementById("heure").innerHTML = 'Heure<br />' + dDate.twHeure();
	oDelais = setTimeout("twAffHeure()",1000);
}


//********************************************************************************************************************
// La fonction rafraichir est appele toutes les secondes et permet de rafrachir s'il y a lieu le tableau des  messages et celui des connects.
//********************************************************************************************************************

function rafraichir(){
			appelsqlmessages();
			appelsqlconnectes();
}

// Rafrachissement ventuel du tableau des messages.
function appelsqlmessages() {

// On dclare un objet XMLHttpRequest ou ActiveX.
	var xhr_object = null;
	if(window.XMLHttpRequest) // FIREFOX
	xhr_object = new XMLHttpRequest();
	else if(window.ActiveXObject) // IE
	xhr_object = new ActiveXObject("Microsoft.XMLHTTP");
	else {  
			alert("Votre navigateur ne supporte pas les objets XMLHTTPRequest..."); 
			return; 
		} 
// Il  s'agit  ici d'un appel Asynchrone. La requte est faite par le fichier requetesql.php et la rponse est:
// 0 s'il n'y aucun nouveau message (dans ce cas on ne fait rien),
// 1 s'il n'y a plus de message ( dans ce cas on repart au dbut),
// les nouveaux  messages  (que l'on insre dans le bloc dont l'identifiant est "tableaumessages").

	xhr_object.open("GET", 'plugins/AristoJchAtX/requetesql.php', true);
	xhr_object.send(null);
	
//	xhr_object.onreadystatechange est ncessaire pour un appel asynchrone avec firefox
	xhr_object.onreadystatechange = function(){ 
	if(xhr_object.readyState == 4){ 
		if(xhr_object.status == 200){ 
// La fonction split dcoupe xhr.responseText en deux suivant le sparateur |.			
			var reponse=xhr_object.responseText;
			if (reponse==1) {			

	document.location="spip.php?page=chat";
							}	  
	else {
			if (reponse!=0) {
								document.getElementById("tableaumessages").innerHTML =reponse;
							}	
				}			
									}
									} 
}											  
}

// Rafrachissement ventuel du tableau des pseudos.
function appelsqlconnectes() {

// On dclare un objet XMLHttpRequest ou ActiveX.
	var xhr_object1 = null;
	if(window.XMLHttpRequest) // FIREFOX
	xhr_object1 = new XMLHttpRequest();
	else if(window.ActiveXObject) // IE
	xhr_object1 = new ActiveXObject("Microsoft.XMLHTTP");
	else {  
	   alert("Votre navigateur ne supporte pas les objets XMLHTTPRequest..."); 
	   return; 
		} 
		
// Il  s'agit  ici d'un appel Asynchrone. La requte est faite par le fichier requetesql1.php et la rponse est:
// 0 s'il n'y aucun changement dans les pseudos et les personnes (dans ce cas on ne fait rien),
// le nouveau tableau des pseudos si celui a chang (que l'on place dans le bloc dont l'identifiant est "pseudos").

	xhr_object1.open("GET", 'plugins/AristoJchAtX/requetesql1.php', true);
	xhr_object1.send(null);
	
//	xhr_object1.onreadystatechange est ncessaire pour un appel asynchrone avec firefox
	xhr_object1.onreadystatechange = function() {  
		if(xhr_object1.readyState == 4){ 
			if(xhr_object1.status == 200){ 
			var reponse=xhr_object1.responseText;
			if (reponse!=0) {
		 	document.getElementById("pseudos").innerHTML =reponse;	
							}			
									}							
										} 
												}	
}

//************************************************************************************************************************
// La fonction suivante permet de valider un message non vide, lorsque le pseudo n'est pas dj pris ou correspond  celui qui poste le message.
//*************************************************************************************************************************

function validmessage(pseu,texte){
if ((texte!='') && (possible==true)) {
// On commence par effacer le message relatif au pseudo.
	document.getElementById('pseudobox').innerHTML='';
// On dclare un objet XMLHttpRequest ou ActiveX
	var xhr_object2 = null;
	if(window.XMLHttpRequest) // FIREFOX
	xhr_object2 = new XMLHttpRequest();
	else if(window.ActiveXObject) // IE
	xhr_object2 = new ActiveXObject("Microsoft.XMLHTTP");
	else {  
			alert("Votre navigateur ne supporte pas les objets XMLHTTPRequest..."); 
			return; 
        } 
// On prend l'heure  laquelle on a post le message.
	var dDate = new Date();
	var heur=dDate.twHeure();

// La fonction escape permet de transformer le texte en symbole passant dans l'url.
// Malheureusement, le symbole + disparait. Pour rsoudre ce problme, on utilise la mthode dcrite ci-aprs.
// L'expression rgulire reg=new RegExp("([+])", "g")  et la mthode replace(reg,"@#$1#@") permettent de remplacer tous les symboles + par @#+#@ (pourquoi pas?).
// Par passage dans l'url cette expression sera transforme en @# #@. Dans le fichier requetesql2, cette chane sera reconnue comme reprsentant un signe +.

   var reg=new RegExp("([+])", "g");
   
// Il  s'agit pas  d'un appel synchrone. La requte est faite par le fichier requetesql2.php qui permet l'insertion du nouveau message.
// En retour, la rponse sera un tableau html d'une ligne dans lequel on a le pseudo, l'heure, le nouveau message et le logo.
//On l'insre dans le bloc dont l'identifiant est "tableaumessages".

	xhr_object2.open("GET", "plugins/AristoJchAtX/requetesql2.php?message="+escape(texte.replace(reg,"@#$1#@"))+"&pseudo="+escape(pseu)+"&heure="+escape(heur),false);
	xhr_object2.send(null);

	if(xhr_object2.readyState == 4){ 
			if(xhr_object2.status == 200){ 
			var reponse=xhr_object2.responseText;													  
			document.getElementById("tableaumessages").innerHTML =reponse;	
	}
									} 
// Le bloc de saisie des messages est rinitialis.
document.saisie.message.value="";
}
}

 

//*******************************************************************************************************************************************
// Cette fonction permet d'effacer les messages . Si on appuie sur la touche effacer, on gardera le message permettant d'identifier la personne et son premier pseudo. 
// Si on quitte la fentre ou l'onglet, l'intgralit des messages sera supprime et la valeur true sera attribue  la variable de session fin.
//********************************************************************************************************************************************

function eff(objectif){

// On dclare un objet XMLHttpRequest ou ActiveX.
	var xhr_object34 = null;
	document.getElementById("tableaumessages").innerHTML ="";
	if(window.XMLHttpRequest) // FIREFOX
	xhr_object34 = new XMLHttpRequest();
	else if(window.ActiveXObject) // IE
	xhr_object34 = new ActiveXObject("Microsoft.XMLHTTP");
	else {  
			alert("Votre navigateur ne supporte pas les objets XMLHTTPRequest..."); 
			return; 
		} 
// Il  s'agit ici de deux appels synchrones. La requte est faite soit par le fichier requetesql3.php qui permet d'effacer tout ce qui a trait  l'utilisateur
// et r-affiche le formulaire de connexion, soit par le fichier requetesql4.php qui supprime tous les messages de l'utilisateur mais permet  celui-ci de rester dans le chat.
	
	if (objectif=='tout'){
				xhr_object34.open("GET", "plugins/AristoJchAtX/requetesql3.php",false);
						}
	else { 
				xhr_object34.open("GET", "plugins/AristoJchAtX/requetesql4.php",false);
		}		
	xhr_object34.send(null); 													  
} 

//*************************************************************************************************************
// Cette fonction permet la vrification de la validit du pseudo (entre 2 et 11 lettres et ne correspondant pas  une autre personne).
//*************************************************************************************************************
 
function verifPseudo(pseudo){

// On vrifie sans ajax si la longueur du pseudo
if(pseudo== ''){
	document.getElementById('pseudobox').innerHTML='<span style="color:#cc0000"><b>'+pseudo+'  </b>Aucun pseudo</span>';
				possible=false;
}
else if(pseudo.length<2){
				document.getElementById('pseudobox').innerHTML='<span style="color:#cc0000"><b>'+pseudo+' : </b>trop court</span>';
				possible=false;
}
else if(pseudo.length>11){
				document.getElementById('pseudobox').innerHTML='<span style="color:#cc0000"><b>'+pseudo+' : </b>trop long</span>';
				possible=false;
}
// Ensuite, si la longueur est convenable, on cherche dans la base de donnes pour voir si le pseudo propos est dj inscrit.
else {

// On dclare un objet XMLHttpRequest ou ActiveX.
	var xhr_object6 = null;
	if(window.XMLHttpRequest) // FIREFOX
	xhr_object6 = new XMLHttpRequest();
	else if(window.ActiveXObject) // IE
	xhr_object6 = new ActiveXObject("Microsoft.XMLHTTP");
	else return(false);
	
// Il s'agit ici d'un appel synchrone. La requte est faite par le fichier requetesql6.php.
				xhr_object6.open("GET","plugins/AristoJchAtX/requetesql6.php?pseudo="+escape(pseudo), false);
				xhr_object6.send(null);
				
// Si ce nom figure dans la base, la rponse est 1 et on met la variable possible  false.
// Sinon, la rponse est 0 et la valeur true est affecte  la variable possible (ce qui permettra la validation ultrieure). 
// Les indications concernant la validit sont indiques juste en dessous de la bote de saisie dans un bloc dont l'identifiant est "pseudobox".
if(xhr_object6.readyState == 4){
	if(xhr_object6.status == 200){ 
		var texte=xhr_object6.responseText;
		if(texte == 1){
						document.getElementById('pseudobox').innerHTML='<span style="color:#cc0000"><b>'+pseudo+' : </b>dj pris</span>';
						possible=false;
						}
		if(texte == 2){
						document.getElementById('pseudobox').innerHTML='<span style="color:yellow"><b>'+pseudo+' : </b>valide</span>';
						possible=true;
						}
								}
	}	
	}	
}

//*********************************************************************************************************
// La fonction change_couleur permet de changer la couleur (trois choix possibles). 
// Pour les messages, on rappelle leurs contenus dans la bonne couleur avec la fonction coulmessages.  
//**********************************************************************************************************

function change_couleur(couleur){
   	document.getElementById("saisie").style.background = couleur;
	document.getElementById("titre").style.background = couleur;
	document.getElementById("nbtoto").style.background = couleur;
	document.getElementById("formeffacer").style.background = couleur;
	document.getElementById("pseudos").style.color = couleur;
	coulmessages(couleur);
}

// On rafraichit le tableau des messages avec la couleur choisie (ncessaire avec firefox).
function coulmessages(couleur) {

// On dclare un objet XMLHttpRequest ou ActiveX.
	var xhr_object7 = null;
	if(window.XMLHttpRequest) // FIREFOX
	xhr_object7 = new XMLHttpRequest();
	else if(window.ActiveXObject) // IE
	xhr_object7 = new ActiveXObject("Microsoft.XMLHTTP");
	else { 
			alert("Votre navigateur ne supporte pas les objets XMLHTTPRequest..."); 
			return; 
		} 
// Il  s'agit ici d'un appel synchrone. La requte est faite par le fichier requetesql7.php et la rponse est le tableau dans la bonne couleur.
	xhr_object7.open("GET", "plugins/AristoJchAtX/requetesql7.php?couleur="+escape(couleur), false);
	xhr_object7.send(null);
// Les messages sont crits dans le bloc dont l'identifiant est tableaumessages.	
	if(xhr_object7.readyState == 4){ 
		if(xhr_object7.status == 200){ 
			var reponse=xhr_object7.responseText;
			document.getElementById("tableaumessages").innerHTML =reponse;																  
									}
									}	
}


